summaryrefslogtreecommitdiffstats
path: root/src
diff options
context:
space:
mode:
authorP. J. McDermott <pjm@nac.net>2012-01-19 20:44:28 (EST)
committer P. J. McDermott <pjm@nac.net>2012-01-19 20:44:28 (EST)
commit69f95caf86642adc253a1cf660e7bb5924316fec (patch)
treecb91628c7366814fc20cd9e9f09ecc3e363a2b24 /src
parent2c0b2a3c5a7ecf4888387864784933b758d356e9 (diff)
Write oh-strip.
Diffstat (limited to 'src')
-rw-r--r--src/oh-strip67
1 files changed, 67 insertions, 0 deletions
diff --git a/src/oh-strip b/src/oh-strip
new file mode 100644
index 0000000..06e1d92
--- /dev/null
+++ b/src/oh-strip
@@ -0,0 +1,67 @@
+#! /bin/sh
+#
+# opkhelper
+# src/oh-strip
+# Strip binary objects of symbols.
+#
+# Copyright (C) 2012 Patrick "P. J." McDermott
+#
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+print_usage()
+{
+ printf 'Usage: %s [-g] [-l] binaryfile...\n' "$1"
+}
+
+opts=$(getopt -n "${0}" -o 'gl' -- "${@}")
+if [ ${?} -ne 0 ]; then
+ print_usage "${0}" >&2
+ exit 1;
+fi
+eval set -- "${opts}"
+while true; do
+ case "${1}" in
+ -g)
+ make_dbg_obj=true
+ shift
+ ;;
+ -l)
+ is_lib=true
+ shift
+ ;;
+ --)
+ shift
+ break
+ ;;
+ *)
+ print_usage "${0}" >&2
+ exit 1
+ ;;
+ esac
+done
+
+if [ -z "${make_dbg_pkg}" ]; then
+ make_dbg_pkg=false
+fi
+if [ -z "${is_lib}" ]; then
+ is_lib=false
+fi
+
+while [ ${#} -gt 0 ]; do
+ if ${make_dbg_pkg}; then
+ objcopy --only-keep-debug "dest/${1}" "dest/usr/lib/debug/${1}"
+ objcopy --add-gnu-debuglink="/usr/lib/debug/${1}" "dest/${1}"
+ fi
+ strip -g "dest/${1}"
+done